Program MoonLineDOS;
{$M $4000,0,0 }
Uses Crt, Dos;
Var
   version : string;
   FileName : string;
   vyhod, Modified : boolean;
   key1, key2 : char;
   UserName, BeginDate, BeginTime, UserTimezZone, City : string;
   Latitude, Longitude : string; { ,  }
   NumOfMonths : string;
   CalcProgression : boolean;

Procedure Init; { Program initialization }
Begin
  version := '0.1';  { Program version }
  FileName := '';    { Project file name }
  Modified := false; { Project modify flag }
  CalcProgression := false;
  FileName := '';
  UserName := '';
  { BeginDate - let it be empty; let user fill it }
  BeginTime := '00 00 00'; UserTimezZone := '3';
End;

Procedure PrintAll;
Var
  ProgressStr, ModifiedStr : string;
Begin
  clrscr;
  if (Modified) then
  begin
     ModifiedStr := ' [*]';
  end
  else
      ModifiedStr := '';
  writeln('ͻ');
  writeln(' MoonLineDOS   v ', version, ' ');
  writeln('ͼ       ');
  writeln(' moon days calculator ');
  writeln('ͻ');
  writeln(' LEGEND: <key> - command/parameter[: value]');
  writeln('         press key to execute command or to change parameter.  ');
  writeln(' Project file: ', FileName, ModifiedStr);
  writeln(' <F1> - About program ͼ');
  writeln(' <n> - new project file');
  writeln(' <o> - open project file');
  writeln(' <s> - save project file');
  writeln(' <a> - save project file as...');
  writeln(' <Esc> - exit');
  writeln(' <u> - user name: ', UserName);
  writeln(' <d> - beginning date (day month year): ', BeginDate);
  writeln(' <t> - beginning time (hours min sec): ', BeginTime);
  writeln(' <z> - timezone: ', UserTimezZone);
  writeln(' <c> - city: ', City);
  writeln(' <i> - latitude () (deg min sec): ', Latitude);
  writeln(' <g> - longitude () (deg min sec): ', Longitude);
  writeln(' <m> - interval of time to calculate (number of months): ', NumOfMonths);
  if (CalcProgression) then
  begin
     ProgressStr := 'V';
  end
  else ProgressStr := ' ';
  writeln(' <p> - also calculate progressions: [', ProgressStr, ']');
  writeln(' <space> - Do Calculations');
End;

Function QueryString(Question : string) : string;
Var
  rslt : string;
Begin
  writeln(' /ĺ');
  writeln('(    Request   ');
  writeln(' \ͼ');
  writeln(Question);
  readln(rslt);
  QueryString := rslt;
End;

function CheckForEmpty(TestStr, IfEmptyStr : string) : boolean; { Check data and make call to md-pri, calculate }
Begin
  if (TestStr = '') then
  begin
    clrscr;
    writeln('ĺ');
    writeln('    ERROR!    ');
    writeln('ͼ');
    writeln(' ', IfEmptyStr);
    writeln('');
    writeln('  Calculations are not applied!');
    writeln('  PRESS ANY KEY');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
    CheckForEmpty := true;
  end
  else CheckForEmpty := false;
End;


Procedure ParseIt(TheLeft, TheRight : string);
Var
  Prgs : string;
Begin
  if (TheLeft = 'nick') then UserName := TheRight;
  if (TheLeft = 'date') then BeginDate := TheRight;
  if (TheLeft = 'time') then BeginTime := TheRight;
  if (TheLeft = 'timezone') then UserTimezZone := TheRight;
  if (TheLeft = 'city') then City := TheRight;
  if (TheLeft = 'shirota') then Latitude := TheRight;
  if (TheLeft = 'dolgota') then Longitude := TheRight;
  if (TheLeft = 'months') then NumOfMonths := TheRight;
  if (TheLeft = 'progressii') then Prgs := TheRight;
  if (Prgs = '0') then begin CalcProgression := false; end
  else CalcProgression := true;
End; { of ParseIt }

Procedure OpenProject;
Var
  fp : text; { file of char }
  buf : string;
  ReadOK : boolean;
  IOWasNotOK : boolean;
  ch : char;
  MustBeLeft, MustBeRight : boolean;
  LeftS, RightS : string;
Begin
  FileName := QueryString('File name of project to OPEN:');
  if (FileName = '') then exit;
  ReadOK := true;
  LeftS := ''; RightS := '';
  Assign(fp, FileName);
  IOWasNotOK := (IOResult <> 0);
  if (IOWasNotOK) then
  begin
    clrscr;
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (IOWasNotOK) then exit;
  Reset(fp);
  Readln(fp, buf);
  if (buf <> '[data]') then
  begin
    clrscr;
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    writeln('   Incorrect file format!');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end
  else
  begin
    MustBeLeft := true; MustBeRight := false;
    while (not Eof(fp)) do
    begin
      Read(fp, ch);
      if (ch = '=') then
      begin
        MustBeLeft := false; MustBeRight := true;
      end
      else
      begin
          if ((ch = #10) or (ch = #13)) then
          begin
               MustBeLeft := true; MustBeRight := false;
               ParseIt(LeftS, RightS);
               { debug: }
              { writeln(LeftS, ' ', RightS); }
               { /debug }
               LeftS := ''; RightS := '';
          end { (ch = #10 or ch = #13) }
          else
          begin
            if (MustBeLeft) then LeftS := LeftS + ch;
            if (MustBeRight) then RightS := RightS + ch;
          end; { else (ch = #10 or ch = #13) }
      end; { else (ch = '=') }
    end; { (not Eof(fp)) }
    if ((ch <> #10) and (ch <> #13)) then
    begin
      ParseIt(LeftS, RightS);
      { debug: }
     { writeln(LeftS, ' ', RightS); }
      { /debug }
    end;
  end;
  Close(fp);
End;  { of OpenProject}

Procedure SaveProject;
Var
  fp : text; { file of char }
  Progressii : char;
  IOWasNotOK : boolean;
Begin
  if (FileName = '') then
  begin
    FileName := QueryString('File name where to SAVE:');
  end;
  if (CheckForEmpty(FileName, 'You did not specified file name!')) then exit;
  Progressii := '0';
  if (CalcProgression) then Progressii := '1';
  Assign(fp, FileName);
  Rewrite(fp);
  IOWasNotOK := (IOResult <> 0);
  if (IOWasNotOK) then
  begin
    clrscr;
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (IOWasNotOK) then exit;
  Writeln(fp, '[data]');
  Writeln(fp, 'nick=', UserName);
  Writeln(fp, 'date=', BeginDate);
  Writeln(fp, 'time=', BeginTime);
  Writeln(fp, 'timezone=', UserTimezZone);
  Writeln(fp, 'city=', City);
  Writeln(fp, 'shirota=', Latitude);
  Writeln(fp, 'dolgota=', Longitude);
  Writeln(fp, 'months=', NumOfMonths);
  Writeln(fp, 'progressii=', Progressii);
  Close(fp);
  Modified := false;
End;  { of SaveProject }

Procedure SaveProjectAs;
Begin
  FileName := QueryString('File name where to SAVE:');
  if (CheckForEmpty(FileName, 'You did not specified file name!')) then exit;
  SaveProject;
End;  { of SaveProjectAs }

Procedure AboutBox;
Begin
  clrscr;
  writeln('                     MoonLineDOS v', version);
  writeln('Ŀ');
  writeln('   md-pri.exe (calculation module) ͻ  ');
  writeln('                                                           ');
  writeln('   The author: Alexander Shnol, fidonet 2:5020/143.16      ');
  writeln('  ͼ  ');
  writeln('                                                             ');
  writeln('   moonln.exe (user interface module) ͻ  ');
  writeln('                                                           ');
  writeln('   The author: Mikhail Shmelev, e-mail: super-m@ya.ru      ');
  writeln('               http://super-m.savesoul.ru/                 ');
  writeln('  ͼ  ');
  writeln('PRESS ANY KEY TO CONTINUE');
  if (readkey = #0) then
  begin
    key2 := readkey;
  end;
End;  { of AboutBox }

Procedure DoCalculation; { Check data and make call to md-pri, calculate }
Var
  fp, FpResult : text;
  IOWasNotOK : boolean;
  Prgrs : string;
  ch : char;
Begin
  if (CheckForEmpty(UserName, 'You did not specified user name!')) then exit;
  if (CheckForEmpty(BeginDate, 'You did not specified beginning date!')) then exit;
  if (CheckForEmpty(BeginTime, 'You did not specified beginning time!')) then exit;
  if (CheckForEmpty(City, 'You did not specified city!')) then exit;
  if (CheckForEmpty(Latitude, 'You did not specified latitude ()!')) then exit;
  if (CheckForEmpty(Longitude, 'You did not specified longitude ()!')) then exit;
  if (CheckForEmpty(NumOfMonths, 'You did not specified interval of time (in months)!')) then exit;
  Assign(fp, 'TEMP.IN');
  Rewrite(fp);
  IOWasNotOK := (IOResult <> 0);
  clrscr;
  if (IOWasNotOK) then
  begin
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    writeln(' ERROR WRITING TO TEMP.IN');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (IOWasNotOK) then exit;
  Prgrs := 'a';
  if (CalcProgression) then Prgrs := 'p';
  Writeln(fp, UserName);
  Writeln(fp, BeginDate);
  Writeln(fp, BeginTime);
  Writeln(fp, UserTimezZone);
  Writeln(fp, City);
  Writeln(fp, Latitude);
  Writeln(fp, Longitude);
  Writeln(fp, NumOfMonths);
  Writeln(fp, Prgrs);
  Writeln(fp, 'TEMP.OUT');
  Close(fp);
  { md-pri call successfully prepared }
  clrscr;
  writeln('Preparing for call md-pri...');
  SwapVectors;
  Exec('md-pri.exe', 'TEMP.IN');
  SwapVectors;
  if (DosError <> 0) then
  begin
    writeln('ͻ');
    writeln('Ȼ DOS ERROR!  ');
    writeln('!ͼ');
    writeln('   DOS error number ', DosError);
    writeln(' PRESS ANY KEY');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (DosError <> 0) then exit;
  IOWasNotOK := false;
  if (DosExitCode <> 0) then
  begin
    writeln('  md-pri returned following DOS exit code: ', DosExitCode);
    writeln('  PRESS <F1> TO STOP OR ANY OTHER KEY TO CONTINUE');
    if (readkey = #0) then
    begin
     key2 := readkey;
     if (key2 = #59) then IOWasNotOK := true;
    end;
  end;
  if (IOWasNotOK) then exit;
  { md-pri call finished }
  writeln('md-pri call successfully done.');
  { now we must reformat result }
  Assign(fp, 'TEMP.OUT');
  Reset(fp);
  IOWasNotOK := (IOResult <> 0);
  if (IOWasNotOK) then
  begin
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    writeln(' ERROR READING TEMP.OUT');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (IOWasNotOK) then exit;
  Assign(FpResult, 'RESULT.TXT');
  Rewrite(FpResult);
  IOWasNotOK := (IOResult <> 0);
  if (IOWasNotOK) then
  begin
    writeln('ͻ');
    writeln('Ȼ I/O ERROR!  ');
    writeln('!ͼ');
    writeln(' ERROR WRITING TO RESULT.TXT');
    if (readkey = #0) then
    begin
     key2 := readkey;
    end;
  end;
  if (IOWasNotOK) then Close(fp);
  if (IOWasNotOK) then exit;
  while (not Eof(fp)) do
  begin
    Read(fp, ch);
    if (ch = ' ') then ch := '.';
    Write(FpResult, ch);
  end;
  Close(fp);
  Close(FpResult);
  writeln(' ͻ');
  writeln(' (i)   Moon days successfully calculated!             ');
  writeln('       For results see table in RESULT.TXT file       ');
  writeln(' ͼ');
  writeln('  PRESS ANY KEY TO CONTINUE');
  if (readkey = #0) then
  begin
    key2 := readkey;
  end;
End; { of DoCalculation }

Begin { Main program body }
  Init;
  vyhod := false;
  repeat
  begin
    PrintAll;
    key1 := readkey;
    if (key1 = #0) then
    begin
     key2 := readkey;
     if (key2 = #59) then AboutBox;
    end; { of if }
    case key1 of         'f': ;
      'n': Init;
      'o': OpenProject;
      's': SaveProject;
      'a': SaveProjectAs;
      #27: vyhod := true;
      'u': begin UserName := QueryString('User name:'); Modified := true; end;
      'd': begin BeginDate := QueryString('Start from date (DD MM YYYY):'); Modified := true; end;
      't': begin BeginTime := QueryString('Time to start from (HH MM SS)(24-hour format):'); Modified := true; end;
      'z': begin UserTimezZone := QueryString('Time zone:'); Modified := true; end;
      'c': begin City := QueryString('Your city:'); Modified := true; end;
      'i': begin Latitude := QueryString('Latitude () (deg min sec):'); Modified := true; end;
      'g': begin Longitude := QueryString('Longitude () (deg min sec):'); Modified := true; end;
      'm': begin NumOfMonths := QueryString('Interval of time to calculate (months):'); Modified := true; end;
      'p': begin CalcProgression := not CalcProgression; Modified := true; end;
      ' ': DoCalculation;
    end; { of case }
  end;
  until vyhod;
End.